% -*- SLang -*-         vi-buffer.sl

% vi-buffer (S-Lang version)
%   by Chikanobu TOYOFUKU (unbound@papaya.juice.or.jp)

% Copyright of the original vi-buffer is

%%%        -*-Emacs-Lisp-*-
%%%          vi-buffer.el
%%%
%%% Copyright (C) 1991 Yutaka NIIBE
%%%
%%% Author: Yutaka NIIBE (niibe@mri.co.jp)
%%%
%%% This idea is due to Chikanobu TOYOFUKU.
%%%
%%%
%%% This program is free software.
%%% ABUSOLUTELY NO WARRANTY.
%%%
%%% See GNU General Public License.
%%%
%%% A copy of the GNU General Public License can be obtained from
%%% the Free Software Foundation, Inc., 675 Mass Ave, Cambridge, MA
%%% 02139, USA.


%   "Command name of vi editor.
% You can change this string to your favorite editor.
% Of cource, it's no mean to change it to JED."
#ifdef UNIX
variable vi_command = "/usr/ucb/vi";
#else
variable vi_command = "c:/tools/bin/jvim";
#endif

%   "The `vi_buffer' command makes files with this base
% name
#ifdef UNIX
variable temp_base_name = "/tmp/vi";
#else
variable temp_base_name = "c:/tmp/vi";
#endif

%   "Invoke vi with the contents of current buffer.
% Then you edit it as you like.
% Leaving vi, the buffer of jed is changed to one in vi."

define vi_buffer()
{
        variable file;

        file = make_tmp_file(temp_base_name);
        bob();
        push_mark();
        eob();
        () = write_region_to_file(file);
        erase_buffer();
        () = system(Sprintf("%s %s\n", vi_command, file, 2));
        () = insert_file(file);
        bob();
        recenter(0);
        () = delete_file(file);
}
